"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.promisifyMiddyMiddlewareFunction = void 0;
var isPromise_1 = require("../utils/isPromise");
function promisifyMiddyMiddlewareFunction(fn) {
    return function (instance) {
        return new Promise(function (resolve, reject) {
            function next(err) {
                if (err) {
                    return reject(err);
                }
                return resolve();
            }
            var result = fn(instance, next);
            if (isPromise_1.isPromise(result)) {
                result.then(resolve, reject);
            }
        });
    };
}
exports.promisifyMiddyMiddlewareFunction = promisifyMiddyMiddlewareFunction;
//# sourceMappingURL=promisifyMiddyMiddlewareFunction.js.map